/////////////////////////////////////////////////////////////////////////////
//  P C 6 0 0 1 V
//  Copyright 1999,2021 Yumitaro
/////////////////////////////////////////////////////////////////////////////
// Based on SLibrary.
/////////////////////////////////////////////////////////////////////////////
// This class is produced by AST. Check homepage when you need any help.
// Mail Address.    ast@qt-space.com
// Official HP URL. http://ast.qt-space.com/
/////////////////////////////////////////////////////////////////////////////
#include <SDL.h>

#include "semaphore.h"


/////////////////////////////////////////////////////////////////////////////
// Mutex クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cMutex::cMutex( void )
{
	mcs = (HCRSECT)SDL_CreateMutex();
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cMutex::~cMutex( void )
{
	SDL_DestroyMutex( (SDL_mutex*)mcs );
}


/////////////////////////////////////////////////////////////////////////////
// Lock
/////////////////////////////////////////////////////////////////////////////
void cMutex::lock( void )
{
	if( mcs ) SDL_LockMutex( (SDL_mutex*)mcs );
}


/////////////////////////////////////////////////////////////////////////////
// Unlock
/////////////////////////////////////////////////////////////////////////////
void cMutex::unlock( void )
{
	if( mcs ) SDL_UnlockMutex( (SDL_mutex*)mcs );
}




/////////////////////////////////////////////////////////////////////////////
// Semaphore クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::cSemaphore( void )
{
	sem = (HSEMAPHORE)SDL_CreateSemaphore( 0 );
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::~cSemaphore( void )
{
	if( sem ) SDL_DestroySemaphore( (SDL_sem*)sem );
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ加算
//
// 引数:	なし
// 返値:	0：成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Post( void )
{
	return SDL_SemPost( (SDL_sem*)sem );
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ待つ
//
// 引数:	なし
// 返値:	0：成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Wait( void )
{
	return SDL_SemWait( (SDL_sem*)sem );
}
